﻿using AsmodeeDigital.PlayReal.Plugin.Domain.GameState;
using ProtoBuf;
using System;
using System.Collections.Generic;

namespace AsmodeeDigital.PlayReal.Samples.Domain.GameState.Events
{
    /// <summary>
    /// Event which indicate that the dices are rolled
    /// </summary>
    [ProtoContract, Serializable]
    public class DicesRolled : IEvent
    {
        /// <summary>
        /// Player local ID
        /// </summary>
        [ProtoMember(1)]
        public int PlayerLocalID { get; set; }

        /// <summary>
        /// UTC time
        /// </summary>
        [ProtoMember(2)]
        public long Time { get; set; }

        /// <summary>
        /// List of index of all rolled dices
        /// </summary>
        [ProtoMember(3)]
        public List<int> DicesIndicesRolled = new List<int>();

        public DicesRolled()
        {
        }

        public DicesRolled(int playerLocalID, List<int> dicesIndicesRolled)
        {
            PlayerLocalID = playerLocalID;
            DicesIndicesRolled.AddRange(dicesIndicesRolled);

            Time = DateTime.Now.Ticks;
        }
    }
}
